
//********************************************************************/
//*                                                                  */
/** Klasse zur Demonstration weiterer Anwendungen des Mathe-Displays */
//*                                                                  */
//********************************************************************/

import gui.*;

import java.applet.*;
import java.awt.*;

public class PythApplet extends java.applet.Applet {

 //*******************************/
 /** Initialisierung des Applets */
 //*******************************/

 public void init() {
 Panel              anyArea       = new Panel();        // Panel fr Mathe-Display
 GridBagPanel       inputPanel    = new GridBagPanel(); // Eingaben des Benutzers
 GridBagLayout      gridbag       = new GridBagLayout();
 GridBagConstraints constr        = new GridBagConstraints();
 String             colorChoice[] = { "weiss",
                                      "gelb",
                                      "orange",
                                      "cyan",
                                      "pink",
                                      "grn",
                                      "rot",
                                      "magenta",
                                      "blau",
                                      "hellgrau",
                                      "grau",
                                      "dunkelgrau",
                                      "schwarz"};

  /*---------------------------------*/
  /* Einstellungen des ersten Panels */
  /*---------------------------------*/

  inputPanel.setInsets( new Insets( 5, 3, 0, 3)); // Komponentenabstnde

  /*------------------------------------------*/
  /* Komponenten in den Eingabebereich setzen */
  /*------------------------------------------*/

  inputPanel.labeledChoice(    "Hintergrundfarbe", colorChoice);
  inputPanel.labeledChoice(    "Zeichenfarbe"    , colorChoice);
  inputPanel.labeledTextField( "Rekursionstiefe", "1");
  inputPanel.labeledTextField( "Kathete1",        "0.36");
  inputPanel.labeledTextField( "Kathete2",        "0.48");
  inputPanel.labeledTextField( "Anfangsposition", "0.32");
  inputPanel.labeledTextField( "Seitenlnge",     "0.15");
  inputPanel.labeledTextField( "X-Bereich von",   "0.0");
  inputPanel.labeledTextField( "X-Bereich bis",   "1.0");
  inputPanel.labeledTextField( "Y-Bereich von",   "0.0");
  inputPanel.labeledTextField( "Y-Bereich bis",   "0.61");
  inputPanel.labeledButton(    "Anzeigen",        "mach hin");

  /*-------------------------------------------------------------------------*/
  /* Vorselektion der Farben (Komponente aus Panel ber Index referenzieren) */
  /*-------------------------------------------------------------------------*/

  ((Choice)inputPanel.getComponent( 1)).select( "grau");
  ((Choice)inputPanel.getComponent( 3)).select( "schwarz");

  /*-------------------------------------------------------------------------------*/
  /* Listener an Startknopf binden (Komponente aus Panel ber Index referenzieren) */
  /*-------------------------------------------------------------------------------*/

  ((Button)inputPanel.getComponent( 23)).addActionListener( new HirnCommand( anyArea));

  /*------------------------*/
  /* Paneele zusammenfassen */
  /*------------------------*/

  this.setLayout( gridbag);                // Layout-Manager Applet festlegen
  constr.fill   = GridBagConstraints.BOTH; // Richtung der Komponentenanpassung
  constr.insets = new Insets( 0, 5, 0, 5); // Abstnde oben, links, unten rechts

  /*------------------------------------------------------*/
  /* Eingabebereich (1/3 kleiner als Darstellungsbereich) */
  /*------------------------------------------------------*/

  constr.weightx = 0.0;                             // KEINE horizontale Gewichtung
  constr.gridwidth  = GridBagConstraints.RELATIVE;  // Zeilenanfang
  gridbag.setConstraints( inputPanel, constr);      // Constraints an Komponente binden
  this.add( inputPanel);                            // Komponente in Container ablegen

  /*------------------------------------------------------*/
  /* Darstellungsbereich (1/3 grsser als Eingabebereich) */
  /*------------------------------------------------------*/

  constr.weightx = 1.0;                             // horizontale Gewichtung
  constr.gridwidth  = GridBagConstraints.REMAINDER; // Zeilenende
  gridbag.setConstraints( anyArea, constr);         // Constraints an Komponente binden
  this.add( anyArea);                               // Komponente in Container ablegen
 }

 public void start()   { }
 public void stop()    { }
 public void destroy() { } 
}
