
package gui;

//************************************************************************/
//*                                                                      */
/** Klasse mit hilfreichen Methoden zur Untersttzung des GridBagLayouts */
//*                                                                      */
//************************************************************************/

import gui.*;

import java.awt.*;

// public class GridBagPanel extends Panel {
public class GridBagPanel extends HandyPanel {

/** GridBagLayout instanzieren */
private GridBagLayout gridbag = new GridBagLayout();

/** Constraints instanzieren */
private GridBagConstraints constraints = new GridBagConstraints();

/** Insets der Komponenten */
private Insets insets = new Insets( 5, 0, 0, 0);

 //***************************/
 /** Aufbau eines Components */
 //***************************/

 public void makeComponent( String name, Component component) {
 Label label = new Label( name);

  component.setName( name);
  constraints.gridwidth = GridBagConstraints.RELATIVE;   // next-to-last in row
  gridbag.setConstraints( label, constraints);
  this.add( label);
  constraints.gridwidth = GridBagConstraints.REMAINDER;  // end row
  gridbag.setConstraints( component, constraints);
  this.add( component);
/*
  gridbag.setConstraints( component, constraints);
  this.add( component);
*/
 }

 //***********************/
 /** Aufbau eines Labels */
 //***********************/
/* HIER
 public Label makeLabel( String name) {
 Label label = new Label( name);

  makeComponent( label);
  return label;
 }
*/
 //***************************/
 /** Aufbau eines TextFields */
 //***************************/
/*
 public TextField makeTextField( String name) {
 TextField field = new TextField( name);

  makeComponent( field);
  return field;
 }
*/
 //************************/
 /** Aufbau eines Buttons */
 //************************/
/*
 public Button makeButton( String name) {
 Button button = new Button( name);

  makeComponent( button);
  return button;
 }
*/
 //*************************/
 /** Aufbau einer Checkbox */
 //*************************/
/*
 public Checkbox makeCheckbox() {
 Checkbox checkbox = new Checkbox();

  makeComponent( checkbox);
  return checkbox;
 }
*/
 //***************************/
 /** Aufbau einer Choice-Box */
 //***************************/
/*
 public Choice makeChoice() {
 Choice choice = new Choice();

  makeComponent( choice);
  return choice;
 }
*/
 //********************************************/
 /** Mit fhrendem Label versehene Choice-Box */
 //********************************************/

 public Choice labeledChoice( String label, String[] choices) {
 Choice choice = new Choice();

  makeComponent( label, choice);
/*
  constraints.gridwidth = GridBagConstraints.RELATIVE;   // next-to-last in row
  makeLabel( label);                                     // Label aufbauen
  constraints.gridwidth = GridBagConstraints.REMAINDER;  // end row
  choice = makeChoice();                                 // Choice aufbauen
  choice.setName( label);                                // Label ist Komponentenname
*/
  /*--------------------------------*/
  /* Auswahlmglichkeiten einsetzen */
  /*--------------------------------*/

  for( int i = 0; i < choices.length; i++) choice.add( choices[i]);
  return choice;  
 }

 //********************************************/
 /** Mit fhrendem Label versehenes TextField */
 //********************************************/

 public TextField labeledTextField( String label, String content) {
 TextField textfield = new TextField( content);

  makeComponent( label, textfield);
/*
  constraints.gridwidth = GridBagConstraints.RELATIVE;  // next-to-last in row
  makeLabel( label);                                    // Label aufbauen
  constraints.gridwidth = GridBagConstraints.REMAINDER; // end row
  field = makeTextField( content);                      // TextField aufbauen
  field.setName( label);                                // Label ist Komponentenname
*/
  return textfield;
 }

 //**********************************************/
 /** Mit fhrendem Label versehene Schaltflche */
 //**********************************************/

 public Button labeledButton( String label, String content) {
 Button button = new Button( content);

  makeComponent( label, button);
/*
  constraints.gridwidth = GridBagConstraints.RELATIVE;  // next-to-last in row
  makeLabel( label);                                    // Label aufbauen
  constraints.gridwidth = GridBagConstraints.REMAINDER; // end row
  button = makeButton( content);                        // Button aufbauen
  button.setName( label);                               // Label ist Komponentenname
*/
  return button;
 }

 //******************************************/
 /** Mit fhrendem Label versehene Checkbox */
 //******************************************/

 public Checkbox labeledCheckbox( String label, boolean state) {
 Checkbox checkbox = new Checkbox();

  checkbox.setState( state);                            // Status der Box festlegen
  makeComponent( label, checkbox);
/*
  constraints.gridwidth = GridBagConstraints.RELATIVE;  // next-to-last in row
  makeLabel( label);                                    // Label aufbauen
  constraints.gridwidth = GridBagConstraints.REMAINDER; // end row
  checkbox = makeCheckbox();                            // Checkbox aufbauen
  checkbox.setName( label);                             // Label ist Komponentenname
*/
  return checkbox;
 }

 //*************************/
 /** Constraints bergeben */
 //*************************/

 public GridBagConstraints getConstraints() {
  return constraints;
 }

 //**************************/
 /** Constaraints festlegen */
 //**************************/

 public void setConstraints( GridBagConstraints constr) {
  this.constraints = constr;
 }

 //********************/
 /** Insets bergeben */
 //********************/

 public Insets getInsets() {
  return insets;
 }

 //********************/
 /** Insets festlegen */
 //********************/

 public void setInsets( Insets ins) {
  this.insets = ins;
  this.constraints.insets = this.insets;
 }

 //*============================*/
 /** Initialisierung des Panels */
 //*============================*/

 private void init() {
  this.setLayout( gridbag); // Layout-Manager Eingabebereich festlegen

  /*---------------------------------*/
  /* Constraints festlegen (default) */
  /*---------------------------------*/

  constraints.insets  = this.insets;             // Insets an Constraints binden
  constraints.fill    = GridBagConstraints.BOTH; // Richtung der Komponentenanpassung
  constraints.weightx = 1.0;                     // horizontale Gewichtung der Komponenten
 }

 //********************************************/
 /** Instanzierung eines GridBagLayout-Panels */
 //********************************************/

 public GridBagPanel() {
  super();
  init();
 }

 public GridBagPanel( int how) {
  super( how);
  init();
 }
}
