
package gui;

//********************************************/
//*                                          */
/**  Klasse der vordefinierten Mitteilungen  */
//*                                          */
//********************************************/

public class Message extends    gui.CenteredDialog
                     implements java.awt.event.ActionListener {

/*---------------------------------------------------------------------*/
/* mgliche Messagetypen (Farbe der Antwortleiste richtet sich danach) */
/*---------------------------------------------------------------------*/

/** Kennung fr Benutzerdefinierte Schaltflchen */
public static final byte USERDEF  = 0x00;

/** Kennung fr Frage-Message */
public static final byte QUESTION = 0x10;

/** Kennung fr Fehler-Message */
public static final byte ERROR    = 0x20;

/** Kennung fr Infomations-Message */
public static final byte INFORM   = 0x40;

/*--------------------*/
/* mgliche Antworten */
/*--------------------*/

/** Kennung fr OK-Button erste Schaltflche */
public static final byte OK     = 0x1;

/** Kennung fr YES-Button zweite Schaltflche */
public static final byte YES    = 0x2;

/** Kennung fr NO-Button dritte Schaltflche */
public static final byte NO     = 0x4;

/** Kennung fr CNCEL-Button vierte Schaltflche */
public static final byte CANCEL = 0x8;

/*------------------------------------------*/
/* Standardbeschriftungen der Schaltflchen */
/*------------------------------------------*/

/** Beschriftungen der Schaltflchen */
private static String buttxt[] = new String[4];

/*--------------------------*/
/* Rckgabewert der Message */
/*--------------------------*/

/** Rckgabewert der Message */
private static int retval = 0;

 //****************************************************************************/
 /** Interner Action-Listener. Messagetyp und Wert der Schaltflche bergeben */
 //****************************************************************************/

 public void actionPerformed( java.awt.event.ActionEvent e) {
 String cmd = e.getActionCommand();
       if ( cmd.equals( buttxt[0])) retval |= OK;
  else if ( cmd.equals( buttxt[1])) retval |= YES;
  else if ( cmd.equals( buttxt[2])) retval |= NO;
  else if ( cmd.equals( buttxt[3])) retval |= CANCEL;
  this.scratch();
 }

 //*================================*/
 /** Panel mit Messagetext aufbauen */
 //*================================*/

 private static java.awt.Panel textPanel( String msg[]) {
 HandyPanel txtpnl = new HandyPanel();

  txtpnl.setLayout( new java.awt.GridLayout( msg.length, 0));

  /*----------------------*/
  /* Messagetext einfgen */
  /*----------------------*/

  for( int cnt = 0; cnt < msg.length; cnt++)
   txtpnl.add( new java.awt.Label( msg[ cnt], java.awt.Label.CENTER));

  return txtpnl;
 }

 //*==================================*/
 /** Panel fr Schaltflchen aufbauen */
 //*==================================*/

 private static java.awt.Panel buttPanel( java.awt.Color col) {
 java.awt.Panel butpnl = new HandyPanel( HandyPanel.ELEVATE + HandyPanel.BORDER, 5, col);

  butpnl.setLayout( new java.awt.GridLayout( 1, 0));
  return butpnl;
 }

 /*========================*/
 /** Schaltflche aufbauen */
 /*========================*/

 private java.awt.Button makeButton( int num) {
 java.awt.Button but = new java.awt.Button();   // neue Button-Instanz
  but.setLabel( buttxt[num]);      // Buttonbeschriftung
  but.addActionListener( this);  // Action-Listener
  return but;
 }

 //************************/
 /** Returnwert bergeben */
 //************************/

 public int getAnswer() {
  return retval;
 }

 //*===========================*/
 /** Dialog zentriert anzeigen */
 //*===========================*/

 private void toDisp() {
  this.pack();
  this.setSize( this.getPreferredSize());
  this.center();
 }

 //************************************/
 /** Benutzerdefinierte Schaltflchen */
 //************************************/

 public Message( java.awt.Frame frm, java.awt.Color col, String ttl, String msg[], String butt[]) {
  super( frm, ttl, true);
 java.awt.Panel butpnl; // Panel mit Schaltflchen

  retval = 0;
  this.setLayout( new java.awt.BorderLayout( 2, 0));

  /*--------------------------------*/
  /* Panel mit Messagetext aufbauen */
  /*--------------------------------*/

  this.add( "Center", textPanel( msg));

  /*--------------*/
  /* Farbe setzen */
  /*--------------*/

  butpnl = buttPanel( col);

  /*-------------------------------------*/
  /* Schatflchen fr Antworten einfgen */
  /*-------------------------------------*/

  for( byte num = 0; num < butt.length; num++) {
   buttxt[num] = butt[num];       // Buttonbeschriftung verallgemeinern
   butpnl.add( makeButton( num)); // Schaltflche aufbauen und ins Panel integrieren
  }
  this.add( "South", butpnl);     // Button-Panel in Message integrieren

  toDisp(); // Dialog in bevorzugter Gre zentriert anzeigen
 }

 //****************************/
 /** Standardisierte Messages */
 //****************************/
 
 public Message( byte msgtyp, byte anstyp, java.awt.Frame frm, String ttl, String msg[]) {
  super( frm, ttl, true);
 java.awt.Panel butpnl; // Panel mit Schaltflchen

  retval = msgtyp;

  /*----------------------------------*/
  /* Beschriftungen der Schaltflchen */
  /*----------------------------------*/

  buttxt[0] = "OK";
  buttxt[1] = "Ja";
  buttxt[2] = "Nein";
  buttxt[3] = "Abbrechen";
  
  java.awt.Color  col = java.awt.Color.gray;
  java.awt.Button but;

  this.setLayout( new java.awt.BorderLayout( 2, 0));

  /*--------------------------------*/
  /* Panel mit Messagetext aufbauen */
  /*--------------------------------*/

  this.add( "Center", textPanel( msg));

  if( anstyp != 0)
      {
       /*------------------------------------------------------*/
       /* Farbe des Antwort-Panels entsprechend dem Messagetyp */
       /*------------------------------------------------------*/

       switch( msgtyp) {
        case QUESTION: col = java.awt.Color.cyan; break;
        case ERROR:    col = java.awt.Color.red;  break;
        case INFORM:   col = java.awt.Color.gray; break;
       }
       butpnl = buttPanel( col);

       /*-------------------------------------*/
       /* Schatflchen fr Antworten einfgen */
       /*-------------------------------------*/

       for( byte num = 0; num < 4; num++) {
        if ((anstyp & ((byte)1 << num)) != 0)
           butpnl.add( makeButton( num)); // Schaltflche aufbauen und ins Panel integrieren
       }
       this.add( "South", butpnl);
    }

  toDisp(); // Dialog in bevorzugter Gre zentriert anzeigen
 }
}
