
package gui;

import mathpack.grammar.*;
import java.awt.*;

//************************************************/
/** Klasse eines Action-Listeners fr ValueInput */
//************************************************/

public class ValueListener implements java.awt.event.ActionListener {

/** Grammatik zum Testen der Eingabe auf Korrektheit */
private Grammar grammar = null;

/** Referenz auf das zu testende TextField */
private TextField totest = null;

/** Kopie des TextField-Inhalts wenn korrekt, sonst null */
private String tested = null;

 //*******************************/
 /** Getesteten String bergeben */
 //*******************************/

 public String getTested() {
  return tested;
 }

 //************************/
 /** Wertobjekt bergeben */
 //************************/
/*
 public Object getValue() {
  return grammar.createValue( tested).get();
 }
*/
 //*****************************************/
 /** Zugrunde liegende Grammatik bergeben */
 //*****************************************/

 public Grammar getGrammar() {
  return grammar;
 }

 //*******************************/
 /** zu testendes Feld festlegen */
 //*******************************/

 public void setTextField( TextField field) {
  totest = field;
 }

 //*=============================================================*/
 /** Speichern des Strings und entfernen des aufrufenden Dialogs */
 //*=============================================================*/

 private void finish( Component component) {
  tested = new String( totest.getText());
  while( !((component == null) || (component instanceof gui.CenteredDialog)))
   component = component.getParent();
  ((gui.CenteredDialog)component).scratch();
 }

 //*********************************************/
 /** Test des TextFields und ggf. Fehlerdialog */
 //*********************************************/

 public void actionPerformed( java.awt.event.ActionEvent e) {
 String cmd    = e.getActionCommand();
 String txt[]  = { "Die Eingabe des Zahlenwertes",
                   "ist grammtikalisch nicht korrekt."};

  if   (grammar == null)
       {
        finish( (Component)e.getSource());
        return;
       }

  if   ( ! grammar.isValuable( totest.getText()))
       {
        gui.Messages.Message( (Component)e.getSource(),
                              Message.ERROR,
                              (byte)Message.OK,
                              "Eingabefehler",
                              txt);
        tested = null;
       }
  else {
        finish( (Component)e.getSource());
        return;
       }
 }

 //*************************************************************************************/
 /** Listener mit Referenzen auf Grammatik und dem zu testenden TextField instanzieren */
 //*************************************************************************************/

 public ValueListener( Grammar gram) {
  this.grammar = gram;
 }
}
